#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Crawler
# DIZ: Enables you to crawl for links to add to your Directory.
# GRAPHIC: ic_crawl.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use LWP::Simple;
use LWP::UserAgent;
use HTTP::Request; 

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

### WRITE URLS TO BE CRAWLED INTO FILES FOR DIFFERENT THREADS

print "Content-type: text/html\n\n"; 


$threads = $q->param('threads');
$timeout = $q->param('timeout');
$googlenr = $q->param('googlenr');
$keywords = $q->param('keywords'); $keywords =~ s/ /+/g;
$ccid = $q->param('ccid');

$nrfiles = $q->param('nrfiles');
$lastpos = $q->param('lastpos');

$metadiz = $q->param('metadiz');
$metakeyw = $q->param('metakeyw');


opendir(DIR,"$data_dir/crawler");
@files = readdir(DIR);
closedir(DIR);

foreach $filename (@files)
	{
	
	if (substr($filename, length($filename) - 4, 4) eq "urls")
		{ 
		($curr_ccid, $tmp_fnumber, $tmp) = split (/_/, $filename);
			
			if ($curr_ccid == $ccid)
				{
				$urls_in_file = $urls_in_file . acs::get_file_contents("$data_dir/crawler/$filename");
				}
			
		}

	}

@lnklines_tmp = split (/\n/, $urls_in_file);

$crit1 = chr(10);
$crit2 = chr(13); 

foreach $item (@lnklines_tmp)
	{
	$item =~ s/\n//gi; $item =~ s/$crit1//gi; $item =~ s/$crit2//gi;

	$dontadd = "";
	foreach $item2 (@lnklines)
		{
		if ($item eq $item2)
			{
			$dontadd = "true";
			}
		}
		
	if ($dontadd ne "true"){push(@lnklines, $item);}
	}

######

@lnklines = sort(@lnklines);

### REMOVE DUPLICATE URLS THAT HAS BEEN CRAWLED
	


$icnt = @lnklines;

$modp = ($icnt % $threads);
$links_per_files = ($icnt - $modp) / $threads;
$links_per_files++;

#print "--> TOTAL LINKS: $icnt <BR><BR>";
#print "--> LINKS PER FILE: $links_per_files <BR><BR>";


$fcnt = 1;
$file_counter = 1;
foreach $fline (@lnklines)
	{
	if ($fcnt == $links_per_files)
		{
		$links_to_write = $links_to_write . $fline . "\n";
			
			$fnamet = "$data_dir/crawler/$file_counter" . "_" . $ccid . "_.url";
			open (FC, "> $fnamet");
				print FC $links_to_write;
			close (FC);
		
		$links_to_write = "";
		$file_counter++;
		$fcnt=0;
		}
		else
		{
		$links_to_write = $links_to_write . $fline . "\n";
		
		}
	
	$fcnt++;
	}



if ($links_to_write ne "")
	{
	$fnamet = "$data_dir/crawler/$file_counter" . "_" . $ccid . "_.url";
	open (FC, "> $fnamet");
		print FC $links_to_write;
	close (FC);	
	}



#print "--> NR OF FILES: $file_counter <BR><BR>";
### OPEN IFRAME TAGS TO DO CRAWLING
#print qq[
#
#threads  $threads  
#timeout  $timeout  
#googlenr $googlenr 
#keywords $keywords 
#ccid $ccid 
#];



$hbox = acs::get_heading_box("$web_url/ic_crawl.gif", "Crawling Sites...", qq[
<p><strong><font color="#FF0000">Please wait untill all threads below has completed it's
crawl. </font></strong>

<ul>
  <li><a href="$admin_url/p_crawl.cgi?fct=index&amp;id=$ccid">After all threads has completed,
    click here to review the sites that has been crawled.</a> </li>
</ul>
]);


print qq[

<html>
<head>
<title>Crawling</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">

</head>
<body>
$hbox
];

for ($ms = 1; $ms <= $file_counter; $ms++)  
	{
	#<font face="Verdana" size="1"><b>Thread $ms:</b></font><BR><BR>
	print qq[
	<iframe src="$admin_url/pcrawl5.cgi?ccid=$ccid&fnumber=$ms&&metadiz=$metadiz&metakeyw=$metakeyw" width="100%" height="80" FRAMEBORDER=0 SCROLLING=NO></iframe>
	];
	} 

print qq[</body></html>];


#########################################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

